#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2two24004xi.py">
#<abstract4xi abstract = "fires to direction two and to distance 2400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2two24004xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2TWO - COORDINATE SIGNS OF SHOOT2TWO4XI: (X + ,Y - ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2two24004xi

#"
#/>

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

# -------------------------------------------------------------------------------------------------
# 2400
# -------------------------------------------------------------------------------------------------
shot2two24004xi = {
        1:'1015x-729y-2048z',
        2:'1016x-47y-2173z',
        3:'1034x-102y-2163z',
        4:'1035x-663y-2060z',
        5:'1046x-2143y-265z',
        6:'1049x-159y-2152z',
        7:'1050x-598y-2073z',
        8:'1060x-218y-2141z',
        9:'1061x-533y-2085z',
        10:'1068x-279y-2131z',
        11:'1069x-468y-2096z',
        12:'1072x-341y-2119z',
        13:'1072x-404y-2108z',
        14:'1156x-2083y-289z',
        15:'1236x-2057y-22z',
        16:'1261x-2017y-313z',
        17:'1341x-1989y-46z',
        18:'1363x-1945y-337z',
        19:'1443x-1915y-70z',
        20:'145x-989y-2181z',
        21:'1461x-1868y-361z',
        22:'1541x-1837y-94z',
        23:'1555x-1787y-384z',
        24:'160x-1247y-2044z',
        25:'1634x-1753y-118z',
        26:'1643x-1700y-408z',
        27:'1723x-1664y-142z',
        28:'1727x-1609y-432z',
        29:'172x-1551y-1823z',
        30:'1805x-1513y-455z',
        31:'1806x-1570y-166z',
        32:'1878x-1414y-479z',
        33:'1885x-1472y-190z',
        34:'192x-958y-2191z',
        35:'1946x-1311y-502z',
        36:'1958x-1371y-214z',
        37:'2007x-1204y-526z',
        38:'2025x-1265y-238z',
        39:'2063x-1095y-549z',
        40:'2086x-1156y-261z',
        41:'210x-2388y-98z',
        42:'2112x-983y-572z',
        43:'2141x-1044y-285z',
        44:'2155x-869y-596z',
        45:'2190x-929y-309z',
        46:'2192x-753y-619z',
        47:'221x-1216y-2056z',
        48:'2223x-636y-642z',
        49:'2233x-812y-333z',
        50:'2247x-517y-665z',
        51:'2264x-398y-688z',
        52:'2269x-693y-357z',
        53:'2275x-278y-711z',
        54:'2277x-38y-757z',
        55:'2279x-158y-734z',
        56:'2299x-573y-380z',
        57:'2318x-621y-6z',
        58:'2322x-451y-404z',
        59:'2338x-328y-428z',
        60:'2347x-498y-30z',
        61:'2348x-205y-451z',
        62:'2351x-82y-475z',
        63:'2369x-375y-54z',
        64:'237x-926y-2201z',
        65:'2385x-250y-78z',
        66:'2394x-125y-102z',
        67:'250x-1522y-1838z',
        68:'280x-1183y-2069z',
        69:'290x-928y-2302z',
        70:'30x-1297y-2018z',
        71:'325x-1488y-1854z',
        72:'334x-2373y-122z',
        73:'336x-1147y-2081z',
        74:'388x-1108y-2092z',
        75:'397x-1451y-1869z',
        76:'438x-1067y-2104z',
        77:'43x-1042y-2161z',
        78:'458x-2351y-146z',
        79:'467x-1411y-1884z',
        80:'484x-1023y-2115z',
        81:'527x-978y-2127z',
        82:'533x-1367y-1898z',
        83:'566x-930y-2138z',
        84:'580x-2322y-170z',
        85:'596x-1319y-1913z',
        86:'602x-882y-2149z',
        87:'635x-832y-2159z',
        88:'656x-1269y-1927z',
        89:'663x-781y-2169z',
        90:'666x-19y-2305z',
        91:'687x-56y-2298z',
        92:'688x-729y-2180z',
        93:'700x-2287y-194z',
        94:'706x-94y-2291z',
        95:'710x-677y-2190z',
        96:'712x-1217y-1942z',
        97:'722x-136y-2284z',
        98:'728x-625y-2199z',
        99:'736x-179y-2277z',
        100:'742x-572y-2209z',
        101:'748x-223y-2269z',
        102:'753x-520y-2218z',
        103:'756x-270y-2261z',
        104:'760x-468y-2227z',
        105:'762x-318y-2253z',
        106:'764x-1161y-1956z',
        107:'764x-367y-2244z',
        108:'764x-417y-2236z',
        109:'812x-1104y-1969z',
        110:'818x-2245y-218z',
        111:'84x-2397y-74z',
        112:'856x-1045y-1983z',
        113:'896x-984y-1996z',
        114:'91x-1576y-1807z',
        115:'932x-921y-2010z',
        116:'934x-2197y-242z',
        117:'95x-1017y-2171z',
        118:'964x-858y-2023z',
        119:'96x-1274y-2031z',
        120:'992x-794y-2035z',
        121:'9x-1596y-1791z'}
        
        
#"
#"/>

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2400two4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2400two4xi(queue2two, consumer_channel2two, publisher_channel2two):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2400TWO4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2400TWO4XI -  QUEUE2TWO: ", queue2two)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2400TWO4XI -  CONSUMER_CHANNEL2TWO: ", consumer_channel2two)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2400TWO4XI -  PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2400TWO4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2two.put(shot2two24004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2400TWO4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2400TWO4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2400TWO4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2two8shot2two24004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2two8shot2two24004xi</nack2put4xi>" 
            
        publisher_channel2two.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2400TWO4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2400TWO4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2400TWO4XI - RETURNING QUEUE OBJECT QUEUE2TWO: ", queue2two, " - TIME: ", time4xi())  
        # 
            
    return queue2two    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verbkb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2two24004xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
        